"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require("react-redux");

var _classAutobind = require("class-autobind");

var _classAutobind2 = _interopRequireDefault(_classAutobind);

var _helpers = require("./helpers");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

exports.default = function (url, mapFromState, mapFromProps) {
  return function (Instance) {
    var Fetcher = function (_Component) {
      _inherits(Fetcher, _Component);

      function Fetcher() {
        _classCallCheck(this, Fetcher);

        var _this = _possibleConstructorReturn(this, (Fetcher.__proto__ || Object.getPrototypeOf(Fetcher)).apply(this, arguments));

        _this.state = {
          isLoading: true,
          isSuccess: null
        };
        (0, _classAutobind2.default)(_this);
        return _this;
      }

      _createClass(Fetcher, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          this._fetchData();
        }
      }, {
        key: "render",
        value: function render() {
          var rest = _objectWithoutProperties(this.props, []);

          var _state = this.state,
              isLoading = _state.isLoading,
              isSuccess = _state.isSuccess;

          var data = this._getFetchedData();
          return _react2.default.createElement(Instance, _extends({}, rest, {
            data: data,
            isLoading: isLoading,
            isSuccess: isSuccess,
            refetch: this._fetchData
          }));
        }
      }, {
        key: "_fetchData",
        value: function _fetchData() {
          _helpers.fetchData.call(this, this._getEndpoint());
        }
      }, {
        key: "_getFetchedData",
        value: function _getFetchedData() {
          var state = this.props.state;

          var currFetchedData = state.__FETCHER__[this._getEndpoint()];
          return this._combineFetchedData(currFetchedData);
        }
      }, {
        key: "_getEndpoint",
        value: function _getEndpoint() {
          return this._endpoint || this._mapToEndpoint();
        }
      }, {
        key: "_mapToEndpoint",
        value: function _mapToEndpoint() {
          var state = this.props.state;

          var mapping = _extends({}, mapFromState(state), mapFromProps(this.props));
          var endpoint = Object.keys(mapping).reduce(function (result, variable) {
            return result.replace(variable, mapping[variable]);
          }, url);
          return endpoint;
        }
      }, {
        key: "_combineFetchedData",
        value: function _combineFetchedData(currFetchedData) {
          var data = this.props.data;

          var prevFetchedData = data;
          if (prevFetchedData) {
            return Array.isArray(data) ? [currFetchedData].concat(_toConsumableArray(data)) : [currFetchedData, data];
          }
          return currFetchedData;
        }
      }]);

      return Fetcher;
    }(_react.Component);

    mapFromState = mapFromState || _helpers.voidFunction;
    mapFromProps = mapFromProps || _helpers.voidFunction;

    return (0, _reactRedux.connect)(function (state) {
      return { state: state };
    })(Fetcher);
  };
};