"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchData = fetchData;
var FETCH_SUCCESSFUL = "__FETCHER__FETCH_SUCCESSFUL";

// function is binded
function fetchData(endpoint) {
  var _this = this;

  fetch(endpoint).then(function (response) {
    var contentType = response.headers.get("content-type");
    if (contentType && contentType.includes("application/json")) {
      return response.json();
    } else {
      throw new Error("REDUX FETCH HOC: Response is not a JSON!");
    }
  }).then(function (data) {
    _this.props.dispatch({
      type: FETCH_SUCCESSFUL,
      endpoint: endpoint,
      payload: data
    });
    _this.setState(successState());
  }).catch(function () {
    return _this.setState(errorState());
  });
}

function successState() {
  return {
    isLoading: false,
    isSuccess: true
  };
}

function errorState() {
  return {
    isSuccess: false,
    isLoading: false
  };
}

var voidFunction = exports.voidFunction = function voidFunction() {
  return {};
};